﻿window.onload = function () {
    //if (url == 'BusinessScope') {
    //    return;
    //}
    init()
    animate()
}
var windowHalfX = null;
var TOP = 300;
var camera = null;//相机
var scene = null;//场景
var renderer = null;//渲染器
var amountX = 80;
var amountY = 80;
var COLOR = 9520058
var particles = null;
var mouseX = 0; //用来跟踪鼠标水平位置
var count = 0;
function init() {
    var SEPARATION = 100;
    var SCREEN_WIDTH = window.innerWidth;
    var SCREEN_HEIGHT = window.innerHeight;
    var container = document.createElement('div');
    windowHalfX = window.innerWidth / 2;
    container.style.position = 'relative';
    container.style.top = "".concat(TOP, "px");
    //console.log(top);
    container.style.height = "".concat(SCREEN_HEIGHT - TOP, "px");
    document.getElementById("IndexLizi").appendChild(container);
    camera = new THREE.PerspectiveCamera(70, SCREEN_WIDTH / SCREEN_HEIGHT, 1, 10000);//角度、宽高比
    camera.position.z = 1000;
    scene = new THREE.Scene(); //			alert(amountX)

    var numParticles = amountX * amountY;
    var positions = new Float32Array(numParticles * 3);
    var scales = new Float32Array(numParticles); //    console.log(scales)
    // 初始化粒子位置和大小
    let i = 0
    let j = 0
    for (let ix = 0; ix < amountX; ix++) {
        for (let iy = 0; iy < amountY; iy++) {
            positions[i] = ix * SEPARATION - ((amountX * SEPARATION) / 2)
            positions[i + 1] = 0
            positions[i + 2] = iy * SEPARATION - ((amountY * SEPARATION) / 2)
            scales[j] = 1
            i += 3
            j++
        }
    }
   
    var geometry = new THREE.BufferGeometry();
    geometry.addAttribute('position', new THREE.BufferAttribute(positions, 3));
    geometry.addAttribute('scale', new THREE.BufferAttribute(scales, 1)); // 初始化粒子材质
    console.log(new THREE.Color(this.COLOR))
    var material = new THREE.ShaderMaterial({
        uniforms: {
            color: {
                value: new THREE.Color(this.COLOR)
            }
        },
        vertexShader: "\n attribute float scale;\n  void main() {\n vec4 mvPosition = modelViewMatrix * vec4( position, 2.0 );\n gl_PointSize = scale * ( 300.0 / - mvPosition.z );\n gl_Position = projectionMatrix * mvPosition;\n          }\n        ",
        fragmentShader: "\n uniform vec3 color;\n void main() {\n if ( length( gl_PointCoord - vec2( 0.5, 0.5 ) ) > 0.475 ) discard;\n            gl_FragColor = vec4( color, 1.0 );\n}\n"
    });
    particles = new THREE.Points(geometry, material);
    scene.add(particles);
    renderer = new THREE.WebGLRenderer({
        antialias: true,
        alpha: true
    });

    particles = new THREE.Points(geometry, material)
    scene.add(particles)

    //渲染
    renderer = new THREE.WebGLRenderer({ antialias: true, alpha: true })
    renderer.setSize(container.clientWidth, container.clientHeight)
    renderer.setPixelRatio(window.devicePixelRatio)
    renderer.setClearAlpha(0)
    container.appendChild(renderer.domElement)
    window.addEventListener('resize', onWindowResize, { passive: false })
    //document.addEventListener('mousemove', onDocumentMouseMove, { passive: false })
    //document.addEventListener('touchstart', onDocumentTouchStart, { passive: false })
    //document.addEventListener('touchmove', onDocumentTouchMove, { passive: false })
}

function render() {
    camera.position.x += (mouseX - camera.position.x) * 0.05;
    camera.position.y = 400;
    camera.lookAt(scene.position);
    var positions = particles.geometry.attributes.position.array;
    var scales = particles.geometry.attributes.scale.array; // 计算粒子位置及大小
    var i = 0;
    var j = 0;
    for (var ix = 0; ix < amountX; ix++) {
        for (var iy = 0; iy < amountY; iy++) {
            positions[i + 1] = Math.sin((ix + count) * 0.3) * 100 + Math.sin((iy + count) * 0.5) * 100;
            scales[j] = (Math.sin((ix + count) * 0.3) + 1) * 8 + (Math.sin((iy + count) * 0.5) + 1) * 8;
            i += 3;
            j++;
        }
    } // 重新渲染粒子
    particles.geometry.attributes.position.needsUpdate = true;
    particles.geometry.attributes.scale.needsUpdate = true;
    renderer.render(scene, camera);
    count += 0.1;
}
function animate() {
    requestAnimationFrame(animate)
    render()
}
var onDocumentMouseMove = function (event) {
    mouseX = event.clientX - windowHalfX
}
var onDocumentTouchStart = function (event) {
    if (event.touches.length === 1) {
        mouseX = event.touches[0].pageX - windowHalfX
    }
}
var onDocumentTouchMove = function (event) {
    if (event.touches.length === 1) {
        event.preventDefault()
        mouseX = event.touches[0].pageX - windowHalfX
    }
}
var onWindowResize = function (event) {
    windowHalfX = window.innerWidth / 2
    camera.aspect = window.innerWidth / window.innerHeight
    camera.updateProjectionMatrix()
    renderer.setSize(window.innerWidth, window.innerHeight)
}
